		.text
		.global		 __low_level_init
		.type		 __low_level_init,function 

		.equ APMC_BASE,0xFFFF4000
		.equ APMC_CGMR,0x20
		.equ APMC_MOSCS,0x01
		.equ APMC_SR,0x30
		.equ APMC_PLL_LOCK,0x02
	
__low_level_init:

		ldr	r5, =APMC_BASE
		ldr  	r5,[r5,#APMC_SR]
		mov 	r10, #APMC_MOSCS 
		orr	r10,r10,#APMC_PLL_LOCK
		cmp     r5,r10
		beq	PLLend

                ldr     r0, =0x002F0002             // MOSCEN = 1, OSCOUNT = 47  (1.4ms/30s)
                ldr     r1, =APMC_BASE              // Get the APMC Base Address
                str     r0, [r1,#APMC_CGMR]         // Store the configuration of the Clock Generator

//- Reading the APMC Status register to detect when the oscillator is stabilized
//------------------------------------------------------------------------------
                mov     r4, #APMC_MOSCS
MoscsLoop:
                ldr     r2, [r1, #APMC_SR]
                and     r2, r4,r2
                cmp     r2, #APMC_MOSCS
                bne     MoscsLoop

//;- Commuting from Slow Clock to Main Oscillator (16Mhz)
//;------------------------------------------------------
                ldr     r0, =0x002F4002             //; MOSCEN = 1, OSCOUNT = 47  (1.4ms/30s)
                str     r0, [r1, #APMC_CGMR]        //; Store the configuration of the Clock Generator

//;-Setup the PLL
//;---------------
                ldr     r0, =0x022F4102             //; MUL = 1, PLLCOUNT = 3, CSS = 1
                str     r0, [r1, #APMC_CGMR]        //; Store the configuration of the Clock Generator

//;- Reading the APMC Status register to detect when the PLL is stabilized
//;-----------------------------------------------------------------------
                mov     r4, #APMC_PLL_LOCK
Pll_Loop:
                ldr     r3, [r1, #APMC_SR]
                and     r3, r4,r3
                cmp     r3, #APMC_PLL_LOCK
                bne     Pll_Loop

//;- Commuting from 16Mhz to PLL @ 32MHz
//;--------------------------------------
                ldr     r0, =0x032F8102             //; CSS = 2, MUL = 1
                str     r0, [r1, #APMC_CGMR]        //; Store the configuration of the Clock Generator

//;- Now the Master clock is the output of PLL @ 32MHz
//;----------------------------------------------------
PLLend:
                mov         pc,lr                  //; Return


