#include "at91m55800.h"
#include "serial.h"
#include "rtc.h"
#include "tcpip.h"

#define NOK 1
#define OK  0

void RTCinit(void)
	{
	unsigned char Hour, Minute, Second, Date, Month, Year, result,x;
	unsigned char receivebuffer[8];
	
	at91_printf(COM1,"\r\n\nInitialing the RTC \r\n\n");
	
	do
	  {
	  result = 0x00;
    	  at91_printf(COM1," Pleas type in the actual time : hh:mm:ss\r\n");

	  for (x=0; x<8; x++)
		receivebuffer[x] = receivechar(COM1)-0x30;
		
	  if(receivebuffer[0]>2)
		result = NOK;
	  if((receivebuffer[1]>4)&(receivebuffer[0]==2))
	  	result = NOK;
	  if(receivebuffer[3]>=6)
	    	result = NOK;
	  if(receivebuffer[4]>=10)
	  	result = NOK;
	  if(receivebuffer[6]>=6)
	  	result = NOK;
	  if(receivebuffer[7]>=10)
	  	result = NOK;
		
	  if (result == NOK)
	  	at91_printf(COM1," bad format !\r\n");
	  }while (result != OK);
	  
	 Hour = receivebuffer[0]*10+receivebuffer[1];
	 Minute = receivebuffer[3]*10+receivebuffer[4];
	 Second = receivebuffer[6]*10+receivebuffer[7];

 	 *RTC_CR   |= RTC_UPDTIM;
	 while (!(*RTC_SR & RTC_ACKUPD));
	 *RTC_SCCR |= RTC_ACKUPD;
	 *RTC_MR = 0x00; // 24 hour mode
	 *RTC_TIMR = ((inttobcd(Hour)<<16)|(inttobcd(Minute)<<8)|(inttobcd(Second)));
	 *RTC_CR   &= ~RTC_UPDTIM;
	 
	 do
	  {
	  result = 0x00;
    	  at91_printf(COM1," Please tyoe in the actual date : dd:mm:yy\r\n");

	  for (x=0; x<8; x++)
		receivebuffer[x] = receivechar(COM1)-0x30;
		
	  if((receivebuffer[0]==3)&(receivebuffer[1]>1))
		result = NOK;
	  if(receivebuffer[0]>3)
		result = NOK;
	  if(receivebuffer[1]>9)
	  	result = NOK;
		
	  if(receivebuffer[3]>1)
	  	result = NOK;
	  if((receivebuffer[3]<1)&(receivebuffer[4]>9))
	  	result = NOK;
		
	  if(receivebuffer[6]>9)
	  	result = NOK;
	  if(receivebuffer[7]>9)
	  	result = NOK;
	
 	  if (result == NOK)
	  	at91_printf(COM1," bad format !\r\n");
			
	  }while (result != OK);
	  
	 Date = receivebuffer[0]*10+receivebuffer[1];
	 Month = receivebuffer[3]*10+receivebuffer[4];
	 Year = receivebuffer[6]*10+receivebuffer[7];

	 at91_printf(COM1," Thanks, the Web-Site is now available under IP-Adresse \r\n\n");
	 at91_printf(COM1," \t\t\t\t %03d.%03d.%03d.%03d",MYIP_1,MYIP_2,MYIP_3,MYIP_4);

	 *RTC_CR   |= RTC_UPDCAL;
 	 while (!(*RTC_SR & RTC_ACKUPD));
	 *RTC_SCCR |= RTC_ACKUPD;
	 *RTC_CALR = ((inttobcd(Date)<<24)|(inttobcd(Month)<<16)|(inttobcd(Year)<<8)|(inttobcd(20))|(inttobcd(1)<<21));
	 *RTC_CR   &= ~RTC_UPDCAL;
	}


unsigned short bcdtoint (unsigned short bcd)
	{
	unsigned short var;
	
	var = bcd & 0x000F;
	var += (((bcd & 0x00F0)>>4)*10);
	var += (((bcd & 0x0F00)>>8)*100);
	var += (((bcd & 0xF000)>>12)*1000);	
	return (var);	
	}
 
unsigned short inttobcd (unsigned short intvar)
	{
	unsigned short bcdvar = 0x00;
	
	bcdvar = intvar % 10;
	intvar = intvar / 10;
	bcdvar |= ((intvar % 10)<<4);
	intvar = intvar / 10;
	bcdvar |= ((intvar % 10)<<8);
	intvar = intvar / 10;
	bcdvar |= ((intvar % 10)<<12);
	return (bcdvar);	
	}


