/************************************************************************/
/*									*/
/*	Beschreibung des Konfigurationsarrays zur Modulkonfiguration	*/
/*									*/
/*	Bit 31 : BOARD ERROR Anzeige					*/
/*	Bit 30 : frei							*/
/* 	Bit 29 : frei							*/
/*	Bit 28 : frei							*/
/*	Bit 27 : DAC							*/
/*	Bit 26 : SERIAL							*/
/*	Bit 25 : LED							*/
/*	Bit 24 : ADC							*/
/*	Bit 23 : frei							*/
/*	Bit 22 : RAM - 8 MByte						*/
/*	Bit 21 :     - 6 MByte						*/
/*	Bit 20 :     - 4 MByte						*/
/*	Bit 19 :     - 3 MByte						*/
/*	Bit 18 :     - 2 MByte						*/
/*	Bit 17 :     - 1 MByte						*/
/*	Bit 16 : RAM - 512 kByte					*/
/*	Bit 15 : frei							*/
/*	Bit 14 : frei							*/
/*	Bit 13 : FLASH	- 16MByte					*/
/*	Bit 12 : 	- 8 MByte					*/
/*	Bit 11 : 	- 4 MByte					*/
/*	Bit 10 : 	- 3 MByte					*/
/*	Bit  9 : 	- 2 MByte					*/
/*	Bit  8 : Flash  - 1 MByte					*/
/*	Bit  7 : EEPROM - 8 kByte					*/
/*	Bit  6 : 	- 4 kByte					*/
/*	Bit  5 : 	- 2 kByte					*/
/*	Bit  4 : EEPROM - 1kByte					*/
/*	Bit  3 : frei							*/
/*	Bit  2 : NO_MAC							*/
/*	Bit  1 : Ethernet						*/
/*	Bit  0 : TwinCAN						*/
/*									*/
/************************************************************************/

#ifndef AT91M55800A_h
#define AT91M55800A_h

// Testspezifische Definitionen zur Konfigurationauswahl

#define BOARDERROR	0x80000000

#define ADC		0x01000000
#define LED		0x02000000
#define SERIAL		0x04000000
#define DAC		0x08000000

#define RAM_512KByte	0x00010000
#define RAM_1MByte	0x00020000
#define RAM_2MByte	0x00040000
#define RAM_3MByte	0x00080000
#define RAM_4MByte	0x00100000
#define RAM_6MByte	0x00200000
#define RAM_8MByte	0x00400000

#define	FLASH_1MByte	0x00000100
#define FLASH_2MByte 	0x00000200
#define FLASH_3MByte 	0x00000400
#define FLASH_4MByte 	0x00000800
#define FLASH_8MByte	0x00001000
#define FLASH_16MByte	0x00002000

#define	EEPROM_1kByte	0x00000010
#define EEPROM_2kByte	0x00000020
#define EEPROM_4kByte	0x00000040
#define EEPROM_8kByte	0x00000080

#define TWINCAN		0x00000001
#define ETHERNET	0x00000002
#define NO_MAC		0x00000004


// Modulspezifisache Definitionen zur Testauswertung

#define PCM_014		0x101000	// 512kByte RAM, 1MByte Flash, 1kByte EEPROM ohne CAN, ohne Ethernet
#define PCM_014_21111	0x402023	// 2MByte RAM (10ns), 2MByte Flash, 2kByte EEPROM mit CAN und Ethernet
#define PCM_014_65111	0x400223	// 2MByte RAM (55ns), 16Mbyte Flash, 2kByte EEPROM mit CAN und Ethernet

// Ende modul- und testspezifische Definitionen

#define EEPROMMASK 	0x00000F0
#define FLASHMASK	0x000FF00
#define RAMMASK		0x0FF0000

#define RAMSIZE_2MByte  0x200000
#define RAMSIZE_1MByte  0x100000
#define RAMSIZE_512KByte 0x80000

#define SIZE_512KByte	0x00080000
#define SIZE_1MByte	0x00100000
#define SIZE_2MByte	0x00200000
#define SIZE_3MByte	0x00300000
#define SIZE_4MByte	0x00400000
#define SIZE_6MByte	0x00600000
#define SIZE_8MByte	0x00800000
#define SIZE_16MByte	0x01000000

#endif
