#include "R_82C900.h"
#include "reg_spi.h"
#include "spi.h"
#include "serial.h"

//***************************************** SPI-CAN Test functionen *****************************************//


void WriteCAN(u_short address, unsigned char value)
	{
	unsigned int x, SPIbuf[2];
	unsigned char startaddress, page;
	
	startaddress = (unsigned char)(address & 0x7F);
	page = (unsigned char)((address & 0x0F80) >> 7);
	SPIsendchar(0x7C|CANWRITE, SP_PCS0);
	SPIsendchar(page, SP_PCS0);
	
	SPIbuf[0] = startaddress | CANWRITE;
	SPIbuf[1] = value;
	
	for(x=0;x<10;x++);

	SPI_TPR = (unsigned int)SPIbuf;
	SPI_TCR = 0x02;
	
	for(x=0;x<20;x++);	
	}
	
unsigned int ReadCAN(u_short address)
	{
	unsigned int x, SPIbuf[2];
	unsigned int SPIrecbuf[2];
	unsigned char startaddress, page;
	
	startaddress = (unsigned char)(address & 0x7F);
	page = (unsigned char)((address & 0x0F80) >> 7);
	SPIsendchar(0x7C|CANWRITE, SP_PCS0);
	SPIsendchar(page, SP_PCS0);
	
	SPIbuf[0] = startaddress & CANREAD;
	
	for(x=0;x<10;x++);	
		
	SPI_TPR = (unsigned int)SPIbuf;
	SPI_RPR = (unsigned int)SPIrecbuf;

	SPI_TCR = 0x02;
	while(SPI_TCR != 0);
	SPI_RCR = 0x02;

	for(x=0;x<20;x++);	
	return((unsigned char)SPIrecbuf[1]);
	
	}

void WriteCANautoinc(u_short address, unsigned char count)
	{
	unsigned char x, startaddress, page;

	startaddress = (unsigned char)(address & 0x7F);
	page = ((unsigned char)((address & 0x0F80) >> 7) | AUTOINCR );
	SPIsendchar(0x7C|CANWRITE, SP_PCS0);
	SPIsendchar(page, SP_PCS0);

	for(x=0;x<10;x++);	

	SPIsendbuffer[0] = startaddress | CANWRITE;
	
	SPI_TPR = (unsigned int)SPIsendbuffer;
	SPI_TCR = (count+1);
	}


void ReadCANautoinc(u_short address, unsigned char count) 
	{
	unsigned char x, startaddress, page;

	startaddress = (unsigned char)(address & 0x7F);
	page = ((unsigned char)((address & 0x0F80) >> 7) | AUTOINCR );
	SPIsendchar(0x7C|CANWRITE, SP_PCS0);
	SPIsendchar(page, SP_PCS0);

	SPIsendbuffer[0] = startaddress & CANREAD;

	for(x=0;x<10;x++);	

	SPI_TPR = (unsigned int)SPIsendbuffer;
	SPI_RPR = (unsigned int)SPIreceivebuffer;	

	SPI_TCR = (count+2);
	SPI_RCR = (count+2);
	
	for(x=0;x<20;x++);		
	}
	
	
void CANsetBaudrate(void)
	{
	unsigned char count;
	unsigned int Initmask[4] = {0x5F,0x00,0x08,0x02};

	for (count=0;count<4;count++)
		WriteCAN((INITCTR+count),Initmask[count]);
	}

void CANinit(void)
	{
	unsigned char count,x,z;
	
	unsigned int config_data[16] = {0xe0011, 0xe0022, 0xe0033, 0xe0044, 0xe0055, 0xe0066, 0xe0077, 0xe0088,		// Data Register 0 bis 4
					0x00, 0x00, 0xB0, 0x05, 							// Arbitration Register
					0xFF, 0xFF, 0xFF, 0xFF}; 							// Acceptance Mask Register
	for(count=0;count<16;count++)
	SPIsendbuffer[count+1] = config_data[count];		// writing Configuration data in Send buffer


		WriteCAN(IOMODE0,0x88);				// aktivating of the Paralell porte
		WriteCAN(OUTREG, 0x00);				// aktivating of hte  CAN-Tranceiver
						
		WriteCAN(ACR, 0x41);				// Configuration of CAN-Node A				
		WriteCAN(ABTR,0x81);				// Baudrate, Timing, etc.
		WriteCAN(ABTR+1,0x36);
		WriteCAN(ACR, 0x01);
	
		WriteCAN(BCR, 0x41);				// Configuration of CAN-Node B
		WriteCAN(BBTR,0x81);				// Baudrate, Timing, etc.
		WriteCAN(BBTR+1,0x36);
		WriteCAN(BCR, 0x01);

		WriteCAN((MOBASE(0)+MSGCTRn),0x55);		// Initialising of Message object 0
		
		WriteCAN((MOBASE(0)+MSGCTRn+1),0x59);
		WriteCAN((MOBASE(0)+MSGCTRn),0x95);
		WriteCANautoinc(MOBASE(0),16);			// Configuration of Message object 0
		WriteCAN((MOBASE(0)+MSGCFGn),0x88);
		WriteCAN((MOBASE(0)+MSGCTRn+1),0x55);		// End of Init of MO 0

		WriteCAN((MOBASE(1)+MSGCTRn),0x55);		// Initialising of Message object 1 for reading
		WriteCAN((MOBASE(1)+MSGCTRn+1),0x55);
		WriteCAN((MOBASE(1)+MSGCFGn),0x82);
		WriteCAN((MOBASE(1)+MSGARn+2),0xB0);
		WriteCAN((MOBASE(1)+MSGARn+3),0x05);
		WriteCAN((MOBASE(1)+MSGCTRn),0x95);		// End of Init of MO 1
		
		WriteCAN(ACR, 0x00);				// CAN Node A activ
		WriteCAN(BCR, 0x00);				// CAN Node B activ
		

	for (z=0;z<10;z++)
		{
    		WriteCAN((MOBASE(0)+MSGCTRn+1),0x65);		// Init	transmit Messageobjekt 0

		for(x=0;x<10;x++);				// Wait for message received 
	
//		at91_printf(COM1," MSGCTR : %x",ReadCAN(MOBASE(1)+MSGCTRn+1));			
		
		if (ReadCAN(MOBASE(1)+MSGCTRn+1) & 0x02)
			{
			ReadCANautoinc(MOBASE(1),8);			// reading 

			WriteCAN((MOBASE(1)+MSGCTRn),0x55);		// Initialising of Message objectes 1 
			WriteCAN((MOBASE(1)+MSGCTRn+1),0x55);
									
			if (ReadCAN(MOBASE(1)+MSGCTRn+1) & 0x08)	
				WriteCAN(MOBASE(1)+MSGCTRn+1,(ReadCAN(((MOBASE(1)+MSGCTRn+1) & 0xf7 )| 0x04))); 	// Reset MSGLST							

			WriteCAN(MOBASE(1)+MSGCTRn+1,(ReadCAN(((MOBASE(1)+MSGCTRn+1) & 0xfd )| 0x01))); 		// Reset Newdat

			WriteCAN((MOBASE(1)+MSGCTRn),0x95);		// End of Init of MO 1
															
//			at91_printf(COM1," MSGCTR : %x",ReadCAN(MOBASE(1)+MSGCTRn+1));			
			
			if (!(memcmp(&SPIreceivebuffer[2],config_data,8)))	// Compare data
				{			
//				at91_printf(COM1," reached data : ");
	
//				for(x=0;x<8;x++)
//					at91_printf(COM1," %X",((unsigned char)SPIreceivebuffer[x+2]));
				
				at91_printf(COM1,"\r Test CAN : sent : %02d   reached : %02d ",z+1, z+1);
				if ((z+1)==10)
					at91_printf(COM1," OK !");
				
				}			
			}
		else    {
			at91_printf(COM1,"no valid data !");
			return;
			}				
		}
	}
	

void TestCAN(void)
	{
	static unsigned char x = 0x00;
	
	at91_printf(COM1,"\r\n Test CAN : ");
	
	if (x == 0x00)
		{
		CANsetBaudrate();
		x++;
		}
	CANinit();
	}

