#include "../h/adcdac.h"
#include "periph/adc/adc.h"
#include "periph/dac/dac.h"
#include "parts/m55800/m55800.h"
#include "parts/m55800/reg_m55800.h"


void initADC(void)
	{
	StructADC *ADCptr;
	
	APMC_PCER |= 0x00018000;							// ADC main clock enable

	ADCptr = ADC0_BASE;	
	ADCptr->ADC_CR  = 0x01;								// Initiate reset
	ADCptr->ADC_MR	= ADC_TRGEN_DIS | ADC_10_BIT_RES | ADC_NORMAL_MODE | 0x0F00;	// provide 1MHz ADC clock @ 32MHz main frequency

	ADCptr 	= ADC1_BASE;
	ADCptr->ADC_CR  = 0x01;								
	ADCptr->ADC_MR	= ADC_TRGEN_DIS | ADC_10_BIT_RES | ADC_NORMAL_MODE | 0x0F00;	
	}
	
void initDAC(void)
	{
	APMC_PCER |= 0x00060000;							// DAC main clock enable
	}
	

unsigned short convertADValue ( unsigned char channel, unsigned char ADC )
	{
	StructADC *ADCptr;
	unsigned short AdcValue = 0x00;
	
	if (ADC == 0x00)	
		ADCptr = ADC0_BASE;
	else if (ADC == 0x01)
		ADCptr = ADC1_BASE;
	else 	return(FALSE);

	ADCptr->ADC_CHDR &= 0x0f;				// disable all channels
	ADCptr->ADC_CHER |= channel;				// enable channel to use
	ADCptr->ADC_CR = 0x02;					// start AD conversion 
	
	while(!(ADCptr->ADC_SR));				// wait until AD conversion is completed
	
	switch (ADCptr->ADC_SR)
		{
		case 0x01 : AdcValue = ADCptr->ADC_CDR[0];
			    break;
		case 0x02 : AdcValue = ADCptr->ADC_CDR[1];	
			    break;
		case 0x04 : AdcValue = ADCptr->ADC_CDR[2];
			    break;
		case 0x08 : AdcValue = ADCptr->ADC_CDR[3];
			    break;		
		}
	return(AdcValue);
	}
	
