/********************************************************************************/
/*	FILE 		: MAIN.C						*/
/*										*/
/*	DESCRIPTION 	: Timerprogram for PHYTEC-Board phyCORE-AT91M55800A	*/
/*										*/
/*			  Initialising Timer with Interruptfunction	*/
/*										*/
/*	AUTHOR		: A.Beuscher						*/
/*			  PHYTEC Metechnik GmbH				*/
/*										*/
/*	VERSOIN		: V1.0							*/
/*										*/
/*	DATE		: 12.12.2002						*/
/********************************************************************************/

#include "irq.h"
#include "serial.h"
#include "../../../Libs/parts/m55800/m55800.h"
#include "../../../Libs/parts/m55800/reg_m55800.h"
#include "../../../Libs/periph/timer_counter/tc.h"
#include "../../../Libs/periph/timer_counter/lib_tc.h"

void InitTimer (void);
void TC_Interrupt (void);

int main (void)
	{
	init_serial(COM1);

	IrqInstall(TC0IRQ, TC_Interrupt, 1, 1);

	InitTimer();
		
	while(1);
	}
	
void InitTimer(void)
	{
	StructTCBlock* TCB0ptr;
	
	APMC_PCER |= 0x40;				// activating Clock  !!!!!
	
	TCB0ptr  = (StructTCBlock*) TCB0_BASE;

	TCB0ptr->TC_BMR |= TC_NONEXC0;

	TCB0ptr->TC[0].TC_CMR |= (TC_CLKS_MCK1024 | TC_BURST_NONE | TC_WAVE);
	TCB0ptr->TC[0].TC_RA = 0x1000;
	TCB0ptr->TC[0].TC_CCR |= (TC_CLKEN | TC_SWTRG);
	
	TCB0ptr->TC[0].TC_IER |= TC_CPAS;
	}	
	
void TC_Interrupt (void)				// Interrupt service routine
	{
	unsigned int TCstatus;
	
	TCstatus = TC0_SR;				// Clear timer interrupt - necessary for clearing
		
	at91_printf(COM1,"\r\n Interrupt - Timerueberlauf : %x", TC0_CV);	

	TC0_CCR = TC_CLKEN | TC_SWTRG;			// Restart Timer
	}
