;------------------------------------------------------------------------------
;-         ATMEL Microcontroller Software Support  -  ROUSSET  -
;------------------------------------------------------------------------------
; The software is delivered "AS IS" without warranty or condition of any
; kind, either express, implied or statutory. This includes without
; limitation any warranty or condition with respect to merchantability or
; fitness for any particular purpose, or against the infringements of
; intellectual property rights of others.
;------------------------------------------------------------------------------
;- File source          : irq_pio.s
;- Object               : Assembler PIO Controller Interrupt Handler.
;-
;- 1.0 00/00/00 JCZ     : Creation
;- 1.1 02/11/00 JPP     : Green Hills
;------------------------------------------------------------------------------

            AREA        IrqPio, CODE, READONLY, INTERWORK

            INCLUDE     ../../periph/aic/irq.mac
            INCLUDE     ../../periph/pio/pio.inc

            IMPORT      pio_c_irq_handler

;------------------------------------------------------------------------------
;- Function             : pio_interrupt_handler
;- Treatments           : Parallel IO Controller Interrupt Handler.
;- Called Functions     : pioa_irq_handler
;- Called Macros        : IRQ_ENTRY, IRQ_EXIT
;------------------------------------------------------------------------------
            EXPORT      pio_asm_irq_handler

pio_asm_irq_handler

;- Manage Exception Entry
            IRQ_ENTRY

;- Call the PIO Interrupt C handler 
            ldr         r0, =pio_c_irq_handler
            mov         r14, pc
            bx          r0
            
;- Manage Exception Exit
            IRQ_EXIT
            
            END
