;------------------------------------------------------------------------------
;-         ATMEL Microcontroller Software Support  -  ROUSSET  -
;------------------------------------------------------------------------------
; The software is delivered "AS IS" without warranty or condition of any
; kind, either express, implied or statutory. This includes without
; limitation any warranty or condition with respect to merchantability or
; fitness for any particular purpose, or against the infringements of
; intellectual property rights of others.
;------------------------------------------------------------------------------
;- File source          : st_irq.s
;- Object               : Assembler System Timer Interrupt Handler.
;-
;- 1.0 18/02/02  PFi    : Creation
;------------------------------------------------------------------------------

            AREA        IrqST, CODE, READONLY, INTERWORK

            INCLUDE     ../../periph/aic/irq.mac
            INCLUDE     ../../periph/system_timer/st.inc

;------------------------------------------------------------------------------
;- Function             : at91_st_irq_asm_handler
;- Treatments           : Sytem Timer Interrupt Handler.
;- Imported Functions   : at91_st_irq_c_handler
;- Exported Functions   : at91_st_irq_asm_handler
;- Called Macros        : IRQ_ENTRY, IRQ_EXIT
;------------------------------------------------------------------------------

            IMPORT      at91_st_irq_c_handler
            EXPORT      at91_st_irq_asm_handler

at91_st_irq_asm_handler

;- Manage Exception Entry
            IRQ_ENTRY

;- Call the System Timer C Interrupt handler 
            ldr         r0, =at91_st_irq_c_handler
            mov         r14, pc
            bx          r0
            
;- Manage Exception Exit
            IRQ_EXIT
            
            END
