#include "parts/m55800/m55800.h"
#include "parts/m55800/reg_m55800.h"
#include "../h/serial.h"

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdarg.h>

void init_serial(unsigned char);
void sendchar(unsigned int, unsigned char);
int receivechar(unsigned int);
void at91_printf(unsigned int, const char*,...);

unsigned char *ptr;			// necessarx for serial output
unsigned char buffer[100];		// necessarx for serial output

//************************ Schnittstellen- Funktionen *******************************//

void init_serial(unsigned char com)
	{
	APMC_PCER |= (com << 2);
	switch (com)
		{
		case COM1:	PIOA_PDR  |= 0x00018000;                  /* Enable RXD0 and TXD0              */
				US0_CR     = 0x000000AC;                  /* Disable RX and TX / Reset Logic      */
				US0_RCR    = 0x00;
				US0_TCR    = 0x00;
			  	US0_BRGR   = 104;  
				US0_TTGR   = 0x10;
			  	US0_MR     = 0x000008C0;                   /* 8 bits, no Parity, 1 Stop bit     */
			  	US0_CR     = 0x00000050;                   /* Enable RX and TX  */  
				break;
		case COM2:	PIOA_PDR  |= 0x000C0000;                  /* Enable RXD0 and TXD0              */		
				US1_CR     = 0x000000AC;                  /* Disable RX and TX / Reset Logic      */
				US1_RCR    = 0x00;
				US1_TCR    = 0x00;
			  	US1_BRGR   = 104;  
				US1_TTGR   = 0x10;
			  	US1_MR     = 0x000008C0;                   /* 8 bits, no Parity, 1 Stop bit     */
			  	US1_CR     = 0x00000050;                   /* Enable RX and TX  */  
				break;
		case COM3:	PIOA_PDR  |= 0x00600000;                  /* Enable RXD0 and TXD0              */		
				US2_CR     = 0x000000AC;                  /* Disable RX and TX / Reset Logic      */
				US2_RCR    = 0x00;
				US2_TCR    = 0x00;
			  	US2_BRGR   = 104;  
				US2_TTGR   = 0x10;
			  	US2_MR     = 0x000008C0;                   /* 8 bits, no Parity, 1 Stop bit     */
			  	US2_CR     = 0x00000050;                   /* Enable RX and TX  */  
				break;
		default: 	break;
		}
	}      

void sendchar(unsigned int com, unsigned char ch)		
	{
	switch (com)
		{
		case COM1:	while(!(US0_CSR & US_TXRDY));
				US0_THR = ch;
				while (!(US0_CSR & US_TXEMPTY));
				break;
		case COM2:	while(!(US1_CSR & US_TXRDY));
				US1_THR = ch;
				while (!(US1_CSR & US_TXEMPTY));
				break;
		case COM3:	while(!(US2_CSR & US_TXRDY));
				US2_THR = ch;
				while (!(US2_CSR & US_TXEMPTY));
				break;			
		default:	break;
		}
	}
	
int receivechar(unsigned int com)
	{
	unsigned int wert = 0,x = 0;
	
	switch (com)
		{
		case COM1:	while(!(US0_CSR & US_RXRDY)); //&& (x != TIMEOUT))
					//x++;
				wert = US0_RHR; 
				return(wert);
		case COM2:	while(!(US1_CSR & US_RXRDY)&& (x != TIMEOUT))
					x++;
				wert = US1_RHR; 
				return(wert);
		case COM3:	while(!(US2_CSR & US_RXRDY)&& (x != TIMEOUT))
					x++;
				wert = US2_RHR; 
				return(wert);
		default :	return(0);
		}
	}
	

void at91_printf(unsigned int com, const char* fmt, ...)
	{
	va_list ap;
	
	va_start(ap, fmt);
	vsprintf((char*)buffer, fmt, ap);
	va_end(ap);

	for(ptr =  buffer;*ptr!='\0';ptr++)
 		sendchar(com,*ptr);		
		
	}

