//*---------------------------------------------------------------------------
//*         ATMEL Microcontroller Software Support  -  ROUSSET  -
//*---------------------------------------------------------------------------
//* The software is delivered "AS IS" without warranty or condition of any
//* kind, either express, implied or statutory. This includes without
//* limitation any warranty or condition with respect to merchantability or
//* fitness for any particular purpose, or against the infringements of
//* intellectual property rights of others.
//*-----------------------------------------------------------------------------
//* File Name           : lib_m40400.h
//* Object              : AT91M40400 Library Header File
//*
//* 1.0 06/12/99 JCZ    : Creation
//*---------------------------------------------------------------------------

#ifndef lib_m40400_h
#define lib_m40400_h

#include    "parts/m40400/m40400.h"

/*------------------*/
/* Special Function */
/*------------------*/
#include    "periph/special_function/lib_sf.h"

/*------------------------*/
/* External Bus Interface */
/*------------------------*/
#include    "periph/ebi/lib_ebi.h"

/*--------------------------*/
/* Power Saving Controller  */
/*--------------------------*/
#include    "periph/power_saving/lib_power_save.h"

/*-------------------------------*/
/* Advanced Interrupt Controller */
/*-------------------------------*/
#include    "periph/aic/ext_irq/lib_ext_irq.h"
#include    "periph/aic/lib_aic.h"

/* Descriptor */
extern const ExtIrqDesc    IRQ0_DESC ;  /* IRQ0 Descriptor */
extern const ExtIrqDesc    IRQ1_DESC ;  /* IRQ1 Descriptor */
extern const ExtIrqDesc    IRQ2_DESC ;  /* IRQ2 Descriptor */
extern const ExtIrqDesc    FIQ_DESC ;   /* FIQ Descriptor */

/*-------------------------*/
/* Parallel I/O Controller */
/*-------------------------*/
#include    "periph/pio/lib_pio.h"

/* Descriptor */
extern const PioCtrlDesc PIO_DESC ;         /* PIO Controller Descriptor */

/*--------*/
/* USARTs */
/*--------*/
/* Definition file */
#include    "periph/usart/lib_usart.h"

/* USART descriptor */
extern const UsartDesc USART0_DESC ;        /* USART 0 Descriptor */
extern const UsartDesc USART1_DESC ;        /* USART 1 Descriptor */

/*----------*/
/* Watchdog */
/*----------*/
/* Definition file */
#include    "periph/watchdog/lib_wd.h"

/*---------------*/
/* Timer Counter */
/*---------------*/
#include    "periph/timer_counter/lib_tc.h"

/* Timert Counter Descriptor */
extern const TCDesc TC0_DESC ;          /* Timer Counter Channel 0 Descriptor */
extern const TCDesc TC1_DESC ;          /* Timer Counter Channel 1 Descriptor */
extern const TCDesc TC2_DESC ;          /* Timer Counter Channel 2 Descriptor */

extern const TCBlockDesc TCB_DESC ;     /* Timer Counter Block Descriptor */

#endif /* lib_m40400_h */
