;------------------------------------------------------------------------------
;-         ATMEL Microcontroller Software Support  -  ROUSSET  -
;------------------------------------------------------------------------------
; The software is delivered "AS IS" without warranty or condition of any
; kind, either express, implied or statutory. This includes without
; limitation any warranty or condition with respect to merchantability or
; fitness for any particular purpose, or against the infringements of
; intellectual property rights of others.
;------------------------------------------------------------------------------
;- File source          : irq_piob.s
;- Object               : Assembler PIO Controller B Interrupt Handler.
;-
;- 1.0 00/00/00 JCZ     : Creation
;- 1.1 02/11/00 JPP     : Green Hills
;------------------------------------------------------------------------------

            AREA        IrqPioB, CODE, READONLY, INTERWORK

            INCLUDE     ../../periph/aic/irq.mac
            INCLUDE     ../../periph/pio/pio.inc

            IMPORT      piob_c_irq_handler

;------------------------------------------------------------------------------
;- Function             : piob_interrupt_handler
;- Treatments           : Parallel IO Controller Interrupt Handler.
;- Called Functions     : piob_irq_handler
;- Called Macros        : IRQ_ENTRY, IRQ_EXIT
;------------------------------------------------------------------------------
            EXPORT      piob_asm_irq_handler

piob_asm_irq_handler

;- Manage Exception Entry
            IRQ_ENTRY

;- Call the PIOA Interrupt C handler 
            ldr         r0, =piob_c_irq_handler
            mov         r14, pc
            bx          r0
            
;- Manage Exception Exit
            IRQ_EXIT

            END
